****************
*zacetne zadeve*
****************
STCKAD  EQU     $007F

	ORG     $DFF8
	FDB     IRQ        ;rezerviramo spomin za vektor IRQ
	FDB     SWI
	FDB     NMI
	FDB     HWRES      ;rezerviramo spomin za vektor reseta

*************
*V/I naslovi*
*************
PIAADR  EQU     $8004      ;zacetni naslov PIA
DRA     EQU     PIAADR     ;DRA ali DDRA
CRA     EQU     PIAADR+1   ;CRA
DRB     EQU     PIAADR+2   ;DRB ali DDRB
CRB     EQU     PIAADR+3   ;CRB

	ORG     $C000      ;tukaj se zares zacne program

*********************************************
*inicializacija PIA v neusklejevalnem nacinu*
*********************************************
INIP    CLRA
	STAA    CRA        ;dostopamo do DDRA          
	STAA    CRB        ;dostopamo do DDRB
	CLRA
	STAA    DRA        ;A je vhod
	LDAA    #$FF
	STAA    DRB        ;B je izhod
	LDAA    #%00000100
	STAA    CRA        ;sprejemamo podatke (ne dostopamo do DDRB)
	STAA    CRB        ;posiljamo podatke (ne dostopamo do DDRA)
	RTS

*********************************************************
*inicializacije PIA v usklajevalnem nacinu za posiljanje*
*********************************************************
INIPP   CLRA
	STAA    CRA        ;dostopamo do DDRA          
	STAA    CRB        ;dostopamo do DDRB
	LDAA    #%11111100
	STAA    DRA        ;najnizja bita A sta vhod, ostali izhod
	LDAA    #$FF
	STAA    DRB        ;B je izhod
	LDAA    #%00100101
	STAA    CRA        ;dostopamo do DRA (ne do DDRA), CA2 je izhod, CA1 
*prozi prekinitve
	LDAA    #%00000100
	STAA    CRB        ;dostopamo do DRB (ne do DDRB)
	
	RTS

**********************************************************
*inicializacije PIA v usklajevalnem nacinu za sprejemanje*
**********************************************************
INIPS   CLRA
	STAA    CRA        ;dostopamo do DDRA          
	STAA    CRB        ;dostopamo do DDRB
	LDAA    #$00
	STAA    DRA        ;A je vhod
	LDAA    #$FF
	STAA    DRB        ;B je izhod
	LDAA    #%00100101
	STAA    CRA        ;dostopamo do DRA (ne do DDRA), CA2 je izhod, CA1 
*prozi prekinitve
	LDAA    #%00000100
	STAA    CRB        ;dostopamo do DRB (ne do DDRB)
	
	RTS

********************
*zacetek posiljanja*
********************
INIPOS  LDAA    #%01010101 ;!!!
	STAA    DRB        ;!!!
	JSR     CAKAJ      ;!!!
	LDAA    #%00000001 ;doloci zacetno stanje luck
	STAA    $0001      ;shrani trenutno stanje luck
	ANDA    #%11110111 ;posilja levo polovico (bit 3 je 0)
	STAA    DRA        ;v DRA poslje vsebino ACCA (uposteva se leva 
*polovica)
	LDAB    DRA        ;bere jo, da sprozi prekinitev in dobi stanje 
*stikal
	STAB    $0002      ;shrani stanje stikal
	LDAA    #$0F
	STAA    $0000      ;shrani napotek, da naslednjic poslje desno 
*polovico
	
	RTS

*********
*cakanje*
*********
CAKAJ   LDX     #$0000     ;IX na 0
ZCAKAJ  INX                ;poveca IX
	CPX     #$5000     ;pogleda, ce je IX prisel do 20480
	BEQ     KCAKAJ     ;ce je, konca s cakanjem

	JMP     ZCAKAJ     ;sicer pa nadaljuje v zanki

KCAKAJ  RTS

*******************
*IRQ za posiljanje*
*******************
IRQP    JSR     CAKAJ
	LDAA    $0000      ;nalozi napotek, kaj poslati
	CMPA    #$0F
	BEQ     VMES       ;ce desno polovico, gre na DESNOP (prej na VMES,
*ker je DESNOP predalec za branch), sicer nadaljuje
	JMP     NAPREJ

VMES    JMP     DESNOP
	
NAPREJ  LDAA    $0001      ;nalozi trenutno stanje luck
	LDAB    $0002      ;nalozi stanje stikal
	ANDB    #%00000001 ;ignorira vse razen 1. stikala
	CMPB    #%00000001
	BEQ     LUCKED     ;ce je prizgano, gre na LUCKED, sicer nadaljuje

	CMPA    #%10000000
	BEQ     OKROGL     ;ce je lucka prisla do konca, gre na OKROGL, sicer 
*nadaljuje

	CLC                ;zbrise carry, da se lucke zagotovo pravilno 
*premaknejo
	ROLA               ;lucke premekne v levo
	JMP     POSLJI

OKROGL  LDAA    #%00000001 ;prizge desno lucko
	JMP     POSLJI

LUCKED  CMPA    #%00000001
	BEQ     OKROGD     ;ce je lucka prisla do konca, gre na OKROGD, sicer 
*nadaljuje

	CLC                ;zbrise carry, da se lucke zagotovo pravilno 
*premaknejo
	RORA               ;lucke premekne v desno
	JMP     POSLJI

OKROGD  LDAA    #%10000000 ;prizge levo lucko

POSLJI  STAA    $0001      ;shrani trenutno stanje luck
	STAA    DRB        ;!!!
	ANDA    #%11110011 ;posilja levo polovico (bit 3 je 0), ne da napotka, 
*naj drugi racunalnik preklopi na posiljanje (bit 2 je 0)
	STAA    DRA        ;v DRA poslje vsebino ACCA (uposteva se leva 
*polovica)
	LDAB    DRA        ;bere jo, da sprozi prekinitev in dobi stanje 
*stikal
	STAB    $0002      ;shrani stanje stikal
	ANDB    #%00000010 ;ignorira vse razen 2. stikala
	STAB    $0003      ;shrani stanje posiljanja/sprejemanja
	CMPB    #%00000000
	BEQ     SPRP       ;ce je ugasnjeno, gre na SPRP, sicer nadaljuje
	
	LDAA    #$0F
	STAA    $0000      ;shrani napotek, da naslednjic poslje desno 
*polovico
	JMP     KIRQP

DESNOP  LDAA    $0001     ;nalozi trenutno stanje luck
	ASLA               ;premakne
	ASLA               ;za 4
	ASLA               ;bite
	ASLA               ;v levo
	ORAA    #%00001000 ;posilja desno polovico (bit 3 je 1)
	ANDA    #%11111011 ;ne da napotka, naj drugi racunalnik preklopi na 
*posiljanje (bit 2 je 0)
	STAA    DRA        ;v DRA poslje vsebino ACCA (uposteva se leva 
*polovica)
	LDAB    DRA        ;bere jo, da sprozi prekinitev in dobi stanje 
*stikal
	STAB    $0002      ;shrani stanje stikal
	ANDB    #%00000010 ;ignorira vse razen 2. stikala
	STAB    $0003      ;shrani stanje posiljanja/sprejemanja
	CMPB    #%00000000
	BEQ     SPRP       ;ce je ugasnjeno, gre na SPRP, sicer nadaljuje

	LDAA    #$F0
	STAA    $0000      ;shrani napotek, da naslednjic poslje levo 
*polovico
	JMP     KIRQP

SPRP    LDAA    #%00001111 ;!!!
	STAA    DRB        ;!!!
	JSR     CAKAJ      ;!!!
	LDAA    #$0F
	STAA    $0004      ;shrani napotek, da je treba preklopiti na 
*sprejemanje
	LDAA    #%00000000
	STAA    $0003      ;shrani, da je zdaj sprejemnik

KIRQP   RTS

********************
*IRQ za sprejemanje*
********************
IRQS    JSR     CAKAJ
	LDAA    DRA        ;nalozi poslano v ACCA in sprozi prekinitev
	TAB                ;skopira poslano v ACCB
	ANDB    #%00001000 ;ignorira vse razen bita 3
	CMPB    #%00001000
	BEQ     DESNOS     ;ce je bit 3 1, gre na DESNO, sicer nadaljuje

	ANDA    #%11110000 ;v desno polovico da 0
	STAA    $0001      ;shrani levo polovico
	JMP     KIRQS

DESNOS  TAB                ;skopira poslano v ACCB
	ANDB    #%00000100 ;ignorira vse razen bita 2
	CMPB    #%00000100
	BEQ     SPRS       ;ce je 1, gre na SPRS, sicer nadaljuje

	TAB                ;skopira poslano v ACCB
	LSRB               ;premakne
	LSRB               ;za 4
	LSRB               ;bite
	LSRB               ;v desno
	LDAA    $0001      ;nalozi levo polovico v ACCA
	ABA                ;kombinira oba dela v ACCA
	STAA    DRB        ;prizge lucke
	JMP     KIRQS

SPRS    LDAA    #%11110000 ;!!!
	STAA    DRB        ;!!!
	JSR     CAKAJ      ;!!!
	LDAA    #$F0
	STAA    $0004      ;shrani napotek, da je treba preklopiti na 
*posiljanje
	LDAA    #%00000010
	STAA    $0003      ;shrani, da je zdaj posiljatelj

KIRQS   RTS

*****
*IRQ*
*****
IRQ     LDAA    $0003      ;nalozi stanje posiljanja/sprejemanja
	CMPA    #%00000010
	BEQ     NAIRQP     ;ce posilja, gre na NAIRQP, sicer nadaljuje

	JSR     IRQS
	JMP     KIRQ

NAIRQP  JSR     IRQP

KIRQ    RTI

*****
*SWI*
*****
SWI     RTI

*****
*NMI*
*****
NMI     RTI

*******
*reset*
*******
HWRES   LDS     #STCKAD    ;zacetni naslov sklada
	JSR     INIP       ;inicializacija PIA za sprejemanje
	LDAA    DRA
	ANDA    #%00000010 ;ignorira vse razen 2. stikala
	STAA    $0003      ;shrani stanje posiljanja/sprejemanja
	CMPA    #%00000010
	BEQ     JEPOS      ;ce je prizgano, gre na JEPOS, sicer nadaljuje

	JSR     INIPS
	JMP     KHWRES

JEPOS   JSR     INIPP      ;inicializacija PIA za posiljanje
	JSR     INIPOS     ;zacne posiljanje

KHWRES  CLRA
	STAA    $0004      ;shrani napotek, da ni treba preklopiti na 
*posiljanje/sprejemanje
	CLI                ;omogoci prekinitve

****************
*glavni program*
****************
ZANKA   LDAA    $0004      ;nalozi napotek o preklapljanju
	CMPA    #$00
	BEQ     KZANKA     ;ce je $00, ponovi zanko, sicer nadaljuje
	
	JSR     CAKAJ
	CMPA    #$0F
	BEQ     NAS        ;ce je $0F, gre na NAS (preklop na sprejemanje), 
*sicer nadaljuje (preklop na oddajanje)

	SEI                ;onemogoci prekinitve
	JSR     INIPP      ;inicializacija PIA za posiljanje
	JSR     CAKAJ
	CLI                ;omogoci prekinitve
	JSR     INIPOS     ;zacne posiljanje
	CLRA
	STAA    $0004      ;shrani napotek, da ni treba preklopiti na 
*posiljanje/sprejemanje
	JMP     KZANKA

NAS     LDAA    #%00001100
	STAA    DRA        ;poslje napotek, naj drugi racunalnik preklopi na 
*posiljanje
	LDAB    DRA        ;bere ga, da sprozi prekinitev
	JSR     INIPS
	CLRA
	STAA    $0004      ;shrani napotek, da ni treba preklopiti na 
*posiljanje/sprejemanje

KZANKA  JMP     ZANKA

	END